<?php
/*
Plugin Name: del.icio.us daily blog post fixer
Plugin URI: http://dougal.gunters.org/blog/2006/04/07/delicious-daily-blog-post-fixer-plugin
Description: If you set up the del.icio.us "daily blog posting" feature, this plugin will let you set the post title to your liking, and add the rel="tag" microformat to the tag links.
Author: Dougal Campbell
Version: 1.0
Author URI: http://dougal.gunters.org/
License: GPL
*/ 

// If we see a title of the form "links for 2006-03-14", rewrite it:
function dp_title_change($text = '') {
	/* 
	 * I could spend a lot of time adding an option screen in
	 * the WP admin interface for this. But it's just one little
	 * text string. So if you don't want your auto-posts to be
	 * called "Daily Links", change it here:
	 */
	$mytitle = "Daily Links";

	$text = preg_replace('/links for \d\d\d\d-\d\d-\d\d/', $mytitle, $text);

	return $text;
}

// Add 'rel="tag"' to any del.icio.us tag links
function dp_del_link_rel_tag($text = '') {
	/* 
	 * Add rel="tag" to del.icio.us links.
	 * 
	 * Once I realized that backslashes need to be escaped inside
	 * of single-quoted strings, things got happy.
	 */

	$regex = '%<a (href=(?:\\\\)?"http://del\.icio\.us/[^/"]+/[^/"]+(?:\\\\)?")>([^<]+)</a>%';

	$text = preg_replace($regex, "<a $1 rel=\"tag\">$2</a>", $text);

	return $text;
}

// Tell WP to do some magic to the post title and content before
// saving it into the db.
add_filter('title_save_pre','dp_title_change');
add_filter('content_save_pre','dp_del_link_rel_tag');

?>